/*****************************************************************************
*
*****************************************************************************/
#include <TApplication.h>
#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>
#include <TGClient.h>
#include <TGButton.h>
#include <TRandom.h>
#include <TMath.h>
#include <TSystem.h>
#include <TStyle.h>
#include <TThread.h>

#include <iostream>
#include <string>
#include <exception>
#include <TMultiGraph.h>
#include <TGraph.h>
#include <TCanvas.h>
#include <TMultiGraph.h>

#include "ADisplay.h"

using namespace std;

ClassImp(ADisplay)

//===============================================================================
void* ADisplay::ConsumerFunc(void* aPtr){

ADisplay* p = (ADisplay*)aPtr;

Double_t value;
if (!gRandom)
     gRandom = new TRandom(0);
TRandom& r= *gRandom;

while(p->aCond){
   for(int i = 0; i < p->aNrGraphs; i++){
      for(Int_t j = 0; j < p->nPoints; j++){
         value  = (Int_t)(TMath::Sin( j * 4 * TMath::Pi() / p->nPoints)*100  );
         value += Int_t((r.Rndm()-0.5)*5);
         p->mGraphs[i]->SetPoint(j, j, value);
         }
      }
   TCanvas* aCanvas = p->fEcan->GetCanvas();
   aCanvas->Update();
   gSystem->Sleep(10);
   }
p->aCond = 1;
}


//===============================================================================
ADisplay::ADisplay(const TGWindow* p, UInt_t w, UInt_t h):TGMainFrame(p,w,h){
 aCond = 0;
 aNrGraphs = 4;
 nPoints = 512;
 gStyle->SetOptDate(0);
 gStyle->SetOptStat(0);
 gStyle->SetOptTitle(kFALSE);
 gStyle->SetTitleFillColor(4);
 gStyle->SetTitleBorderSize(1);
 gStyle->SetTitleBorderSize(1);
 gStyle->SetOptFit(0);
 gStyle->SetFrameFillColor(1);
 gStyle->SetFrameBorderSize(1);
 gStyle->SetFrameBorderMode(0);
 gStyle->SetCanvasColor(1);
 gStyle->SetCanvasBorderSize(1);
 gStyle->SetCanvasBorderMode(0);
 gStyle->SetPadColor(1);
 gStyle->SetPadBorderSize(2);
 gStyle->SetPadBorderMode(0);
 gStyle->SetLabelSize(0.04,"X");
 gStyle->SetLabelSize(0.04,"Y");
 gStyle->SetAxisColor(32, "x");
 gStyle->SetAxisColor(32, "y");
 gStyle->SetLabelColor(32, "x");
 gStyle->SetLabelColor(32, "y");
 gStyle->SetPadGridX(1);
 gStyle->SetPadGridY(1);
 gStyle->SetPalette(1);



 fEcan = new TRootEmbeddedCanvas(0,this,200,200);
 AddFrame(fEcan, new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandX  | kLHintsExpandY,0,0,1,1));

 TGHorizontalFrame* hframe1 = new TGHorizontalFrame(this, 200, 40);
 	update = new TGTextButton(hframe1, "Update Start");
 	update->Connect("Clicked()", "ADisplay", this, "UpdateGraph()"); 
 	hframe1->AddFrame(update, new TGLayoutHints(kLHintsCenterX,5,5,5,5));
 AddFrame(hframe1, new TGLayoutHints(kLHintsCenterX, 2, 2, 2, 2)); 

 TGHorizontalFrame* hframe2 = new TGHorizontalFrame(this, 200, 40);
 	updateStop = new TGTextButton(hframe2, "Update Stop");
 	updateStop->Connect("Clicked()", "ADisplay", this, "UpdateStop()"); 
	updateStop->SetEnabled(kFALSE);
 	hframe2->AddFrame(updateStop, new TGLayoutHints(kLHintsCenterX,5,5,5,5));
 AddFrame(hframe2, new TGLayoutHints(kLHintsCenterX, 2, 2, 2, 2)); 

 Connect("CloseWindow()", "ADisplay", this, "CloseWindow()");
 DontCallClose();


 SetWindowName("Main Window");
 MapSubwindows();
 Resize(GetDefaultSize());
 MapWindow();
}

//===============================================================================
void ADisplay::UpdateGraph(){
 updateStop->SetEnabled(kTRUE);
 update->SetEnabled(kFALSE);
 aCond = 1;
 aConsumer = new TThread("Consumer", (void(*) (void *))ConsumerFunc, (void*) this);
 aConsumer->Run();

}

//===============================================================================

void ADisplay::CloseWindow(){
UpdateStop();
this->~ADisplay();
}
//===============================================================================
void ADisplay::UpdateStop(){
 aCond = 0;
 updateStop->SetEnabled(kFALSE);
 update->SetEnabled(kTRUE);
 if(aConsumer){
    TThread::Delete(aConsumer);
    delete aConsumer;
    aConsumer = 0;
   }
}

//===============================================================================

ADisplay::~ADisplay(){

aCond = 0;
for(int i = 0; i < aNrGraphs; i++){
   delete  mGraphs[i];
   }
delete [] mGraphs;
delete mMultiGraph;
update->Disconnect();
updateStop->Disconnect();
gApplication->Terminate(0);
}

//===============================================================================

void ADisplay::InitGraph(){
   mMultiGraph = new TMultiGraph();
   mGraphs = new TGraph*[ aNrGraphs ];

   char name[20];
   for(int i = 0; i < aNrGraphs; i++){
      sprintf(name,"g_%d",i);
      mGraphs[i] = new TGraph( nPoints );
      for(Int_t j = 0; j < nPoints; j++){
          mGraphs[i]->SetPoint(j, j, 0);
         }
      mGraphs[i]->SetMarkerColor(i+2);
      mGraphs[i]->SetLineColor(i+2);
      mGraphs[i]->SetMarkerStyle(21);
      mGraphs[i]->SetMarkerSize(0.3);

      mMultiGraph->Add(mGraphs[i], "lp");
 
    }

    TCanvas* aCanvas = fEcan->GetCanvas();
    mMultiGraph->Draw("a");
    mMultiGraph->SetMaximum(120);
    mMultiGraph->SetMinimum(-120);


    aCanvas->Update(); 

}
